//=============================================================================
// UIExtension.js
//=============================================================================


(function () {

    //////////////////////////////////////////////////////////////////////////////////////////////// SceneMap

    Scene_Map.prototype.isFastForward = function () {
        return false;
    };

    //////////////////////////////////////////////////////////////////////////////////////////////// Name Box
    Window_NameBox.prototype.windowWidth = function () {
        this.resetFontSettings();
        var dw = this.textWidthEx(this._text);
        dw += this.padding * 2;
        return dw + eval(Yanfly.Param.MSGNameBoxPadding);
    };

    Window_NameBox.prototype.windowHeight = function () {
        return this.fittingHeight(1) - 6;
    };

    Window_NameBox.prototype.standardPadding = function () {
        return 12;
    };

    Window_NameBox.prototype.textPadding = function () {
        return 0;
    };

    //////////////////////////////////////////////////////////////////////////////////////////////// Scene_Menu
    // scenen
    Scene_Menu.prototype.commandHScene = function () {
        this._commandWindow.close();
        SceneManager.push(Scene_HScene);
    }

    Scene_Menu.prototype.commandHState = function () {
        console.log('show h state');
    }

    var _Scene_Menu_createCommandWindow = Scene_Menu.prototype.createCommandWindow;
    Scene_Menu.prototype.createCommandWindow = function () {
        _Scene_Menu_createCommandWindow.call(this);
        this._commandWindow.setHandler('h_scene', this.commandHScene.bind(this));
        this._commandWindow.setHandler('h_state', this.commandHState.bind(this));
        this.addWindow(this._commandWindow);
    };

    // skill
    // Scene_Menu.prototype.commandPersonal = function () {
    //     this._statusWindow.setFormationMode(false);
    //     this._statusWindow.selectLast();
    //     this._statusWindow.activate();
    //     this._statusWindow.setHandler('ok', this.onPersonalOk.bind(this));
    //     this._statusWindow.setHandler('cancel', this.onPersonalCancel.bind(this));
    //     SceneManager.push(Scene_Skill);
    // };

    Scene_Menu.prototype.create = function () {
        Scene_MenuBase.prototype.create.call(this);
        this.createCommandWindow();
        // this.createGoldWindow();
        this.createStatusWindow();
    }

    // Scene_Menu.prototype.createStatusWindow = function () {
    //     this._statusWindow = new Window_MenuStatus(this._commandWindow.width, 0);
    //     this._statusWindow.reserveFaceImages();
    //     // this.addWindow(this._statusWindow);
    // };

    // window
    // Window_MenuCommand.prototype.makeCommandList = function () {
    //     this.addMainCommands();
    //     this.addFormationCommand();
    //     this.addOriginalCommands();
    //     this.addOptionsCommand();
    //     this.addSaveCommand();
    //     this.addGameEndCommand();
    // }

    // Window_MenuCommand.prototype.initialize = function () {
    //     this.clearCommandList();
    //     this.makeCommandList();
    //     var width = this.windowWidth();
    //     var height = this.windowHeight();
    //     var posX = (SceneManager._screenWidth - width) / 2;
    //     var posY = (SceneManager._screenHeight - height) / 2;
    //     Window_Selectable.prototype.initialize.call(this, posX, posY, width, height);
    //     this.refresh();
    //     this.select(0);
    //     this.activate();
    // };

    //////////////////////////////////////////////////////////////////////////////////////////////// Scene_HScene
    // scene
    function Scene_HScene() {
        this.initialize.apply(this, arguments);
    }

    Scene_HScene.prototype = Object.create(Scene_MenuBase.prototype);
    Scene_HScene.prototype.constructor = Scene_HScene;

    Scene_HScene.prototype.initialize = function () {
        Scene_MenuBase.prototype.initialize.call(this);
    };

    Scene_HScene.prototype.create = function () {
        Scene_MenuBase.prototype.create.call(this);
        this.createHSceneWindow();
    };

    Scene_HScene.prototype.start = function () {
        Scene_MenuBase.prototype.start.call(this);
        this._hSceneWindow.refresh();
    };

    Scene_HScene.prototype.createHSceneWindow = function () {
        this._hSceneWindow = new Window_HScene(0, 0, Graphics.boxWidth, Graphics.boxHeight);
        this._hSceneWindow.setHandler('ok', this.onPressOk.bind(this));
        this._hSceneWindow.setHandler('cancel', this.popScene.bind(this));
        this.addWindow(this._hSceneWindow);
    };

    Scene_HScene.prototype.onPressOk = function () {
        // this._hSceneWindow.currentSelect;

        // switch (this._commandWindow.currentSymbol()) {
        // case 'skill':
        //     SceneManager.push(Scene_Skill);
        //     break;
        // case 'equip':
        //     SceneManager.push(Scene_Equip);
        //     break;
        // case 'status':
        //     SceneManager.push(Scene_Status);
        //     break;
        // }
    };

    // window
    function Window_HScene() {
        this.initialize.apply(this, arguments);
    }

    Window_HScene.prototype = Object.create(Window_Selectable.prototype);
    Window_HScene.prototype.constructor = Window_HScene;

    Window_HScene.H_SCENE_THUMB = [
        'hscene_thumb_1',
        'hscene_thumb_2',
        'hscene_thumb_3',
        'hscene_thumb_4',
        'hscene_thumb_5',
        'hscene_thumb_6',
        'hscene_thumb_7',
        'hscene_thumb_8',
        'hscene_thumb_9',
        'hscene_thumb_10',
        'hscene_thumb_11',
        'hscene_thumb_12',
    ];

    Window_HScene.prototype.initialize = function (x, y, width, height) {
        Window_Selectable.prototype.initialize.call(this, x, y, width, height);
        this.activate();
        this._mode = null;
    };

    Window_HScene.prototype.processOk = function () {
        Window_Selectable.prototype.processOk.call(this);
    };

    Window_HScene.prototype.drawThumb = function() {
        var bitmap = ImageManager.loadPicture('1_1');
        this.contents.blt(bitmap, 100, 0, 200, 100, 0, 50);
    }

    Window_HScene.prototype.drawItem = function (index) {
        
    };

    Window_HScene.prototype.refresh = function () {
        this.drawThumb();
        // ImageManager.loadPicture('1_1');
    }

    Window_HScene.prototype.itemRect = function (index) {
        return {
            x: index % 10 * 42 + Math.floor(index % 10 / 5) * 24,
            y: Math.floor(index / 10) * this.lineHeight(),
            width: 42,
            height: this.lineHeight()
        };
    };

    Window_HScene.prototype.maxCols = function () {
        return 3;
    };

    Window_HScene.prototype.spacing = function () {
        return 12;
    };

    Window_HScene.prototype.itemWidth = function () {
        return 200;
    };

    Window_HScene.prototype.itemHeight = function () {
        return 100;
    };
})();